--[[
Addon: 			Bang! Libram Swap
Description: 	A Mod to maximise the power of this versitile item slot for all paladin specs.
Author:			Bangerz of Jubei'Thos (Oceanic)
Website:		http://www.curse.com/downloads/details/12351/ or www.FadeGuild.com.au
Credit to:		BHL:HasBoL and HasMendingBuff code from Ladenedge's Holy Librams.
Thanks to:		Katana/Calthas, Stormbringer, for their help with translations.

Release: 2.42.J6

The LoM Buff slider is back.


]]--

BangLibramSwap = LibStub("AceAddon-3.0"):NewAddon("BangLibramSwap", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0")
local BangLibramSwap = BangLibramSwap
--local L = LibStub("AceLocale-3.0"):GetLocale("BangLibramSwap", true)
local L = AceLibrary("AceLocale-2.2"):new("BangLibramSwap")
local optionsFrame

function BangLibramSwap:OnInitialize()

if (select(2, UnitClass("player")) ~= "PALADIN") then
    		DEFAULT_CHAT_FRAME:AddMessage("BLS: Not Loaded!", 0.0, 1.35, 0.3)
	return	 	
end

--DBObject:RegisterDefaults(defaults, {
local defaults = {
    profile = {
   Enabled=true,
   Version="Bang Libram Swap 2.42.J6",
   Mp5Mode=true,
   AutoMode=true,
   AutoSpec=true,
   LoAT=false,
   LotL=true,
   LoSR=true,
   LoSRFoL=false,
   LoM=false,
   NoLoM=false,
   LoL=false,
   BBoN=true,
   ret=false,
   prot=false,
   holy=true,
   UseLoM=true,
   DJ=true,
   JB=true,
   HS=true,
   PVEOverride=false,
   ProtDP=false,
   HolyES=true,
   HolyCD=true,
   HolyDP=true,
   Debug=false,
   AV=false,
   CR=false,
   Glad1=false,
   Glad2=false,
   Glad3=true,
   Glad4=false,
   RetJudge1=false,
   RetJudge2=false,
   RetJudge3=true,
   RetJudge4=false,
   RP=true,
   RefreshWindow=4.0,
   JudgementCooldown=8.0,
   STFU3=false,}
}

  options = {
    type="group",
    name = "Bang! Libram Swap",
    childGroups = "tab",
    plugins = {},
    args = {
    --	frame = {
	  -- Front Page
     			 GUI = {
          		  type = "execute",
          		  name = "`GUI`",
          		  desc = "Diplay the GUI",
           		 func = function() BangLibramSwap:ChatCommand() end,
           		 order=-1,
           		 guiHidden = true,

        },

			  enable = {
           		 type = "toggle",
           		 name = "Enabled",
           		 desc = "Libram Swaps Enabled",
    		     get=function() return self.db.profile.Enabled end,
    	         set=function(v) BangLibramSwap:SetEnabled() end,
                order=1,
              },
                pvp = {
            		type = "toggle",
           			 name = "PVP Mode",
           		 	desc = "Use PVP librams",
    				get=function() return (not(self.db.profile.Mp5Mode)) end,
    				set=function() BangLibramSwap:SetPVPMode() end,
                	order=2,
                },
             
                pve = {
            		type = "toggle",
            		name = "PVE Mode",
            		desc = "Use PVE librams",
    				get=function() return self.db.profile.Mp5Mode end,
    				set=function() BangLibramSwap:SetPVEMode() end,
               		 order=4,
              },
              
              AutoMode = {
            type = "toggle",
            name = "Auto Detect PVP/PVE",
            desc = "Automatically Detect PVP/PVE",
            order=3,
			get=function() return self.db.profile.AutoMode end,
    		set=function(v) BangLibramSwap:SetAutoMode() end,

            },
              
            debug = {
            type = "toggle",
            name = "Debug",
            desc = "Toggle Debug Messages",
            order = 7,
            guiHidden=true,
    		get=function() return self.db.profile.Debug end,
    		set=function(v) BangLibramSwap:SetDebug() end

        },   

     HolyMode = {
            type = "toggle",
            name = "Holy Mode",
            desc = "Toggle Healing and Spell Damage Librams",
            order = 8,
    		get=function() return self.db.profile.holy end,
    		set=function() BangLibramSwap:SetHolyMode() end,

        },

     RetMode = {
            type = "toggle",
            name = "Retribution Mode",
            desc = "Toggle Retribution Damage and Resilience librams",
            order = 6,
    		get=function() return self.db.profile.ret end,
    		set=function() BangLibramSwap:SetRetMode() end,

        },


     ProtMode = {
            type = "toggle",
            name = "Protection Mode",
            desc = "Toggle Tanking and Spell Damage Librams",
            order = 10,
    		get=function() return self.db.profile.prot end,
    		set=function() BangLibramSwap:SetProtMode() end,

        },

    

	AutoSpec = {
            type = "toggle",
            name = "Auto Change Spec",
            desc = "Automatically choose spec based on abilities used",
            order = 5,
			get=function() return self.db.profile.AutoSpec end,
    		set=function(v) BangLibramSwap:SetAutoSpec() end

        },
		  
    frame2 = {    
	   
	type="group",
    name = "Holy Librams",
    childGroups = "tab",
    plugins = {},
    args = {
	   
	        HolyLightHeader = {
            type = "header",
            name = "Holy Light Libram #1:",
            desc = " ",
            order = 0,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,

        	},
	   
	    	LoM2 = {
            type = "toggle",
            name = "Use the Libram of Mending +HL #2",
            desc = "Toggle using the Libram of Mending on HL #1",
            width = "full",
			order = 1,
    		get=function() return self.db.profile.UseLoM end,
    		set=function() BangLibramSwap:UseLoM() end,
            },
	   
	        LoM = {
            type = "toggle",
            name = "*Only* Use the Libram of Mending ",
            desc = "Toggle using the Libram of Mending *Only* (This disables HL#2 below)",
            width = "full",
			order = 2,
    		get=function() return self.db.profile.LoM end,
    		set=function() BangLibramSwap:LoM() end,

            },

            NoLoM = {
            type = "toggle",
            name = "Do not use the Libram of Mending",
            desc = "Disable using the Libram of Mending (If you dont have it)",
            width = "full",
			order = 3,
    		get=function() return self.db.profile.NoLoM end,
    		set=function() BangLibramSwap:NoLoM() end,
    		},
    		
    		LoMRecast = {
            type = "range",
            name = "Recast LoM Buff@",
            desc = "Recast LoM Buff @ X Time Temaning",
            min = 1,
            max = 25,
            step = 1,
			order = 4,
            get = function()
				return self.db.profile.RefreshWindow
				end,
			set = function(info, value)
				self.db.profile.RefreshWindow = value
				BangLibramSwap:SetLoMRecast(value)
				end
			},
            
            
            HolyLight2Header = {
            type = "header",
            name = "Holy Light Libram #2:",
            desc = " ",
            order = 5,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
    		},
        
	        LoAT = {
            type = "toggle",
            name = "Libram of Absolute Truth",
            desc = "Use the Libram of Absolute Truth on 2nd HL (You may use LoSR but it is not recommended)",
            width = "full",
			order = 6,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,

        	},
	   
	        LotL = {
            type = "toggle",
            name = "Libram of the Lightbringer",
           desc = "Use the Libram of the Lightbringer on 2nd HL (You should also select LoSR)",
            width = "full",
			order = 7,
    		get=function() return self.db.profile.LotL end,
    		set=function() BangLibramSwap:LotL() end,

           },


            LoSR = {
            type = "toggle",
            name = "Libram of Souls Redeemed (if BoL)",
            desc = "Toggle the Libram of Souls Redeemed on 2nd HL (You should also select LotL",
            width = "full",
			order = 8,
    		get=function() return self.db.profile.LoSR end,
    		set=function() BangLibramSwap:LoSR() end,

            },
	   
	        FlashofLightHeader = {
            type = "header",
            name = "PVE Flash of Light Librams:",
            desc = " ",
            order = 10,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	   
	        LoL = {
            type = "toggle",
            name = "Libram of Light",
            desc = "Toggle the Libram of Light",
            width = "full",
			order = 11,
    		get=function() return self.db.profile.LoL end,
    		set=function() BangLibramSwap:LoL() end,

            },

            BBoN = {
            type = "toggle",
            name = "Blessed Book of Nagrand",
            desc = "Toggle the Blessed Book of Nagrand",
            order = 12,
            width = "full",
    		get=function() return self.db.profile.BBoN end,
    		set=function() BangLibramSwap:BBoN() end,

             },

       

	        LoSRFoL = {
             type = "toggle",
            name = "Libram of Souls Redeemed (if BoL)",
            desc = "Toggle the Libram of Souls Redeemed on FoL if BoL is up",
            width = "full",
			order = 13,
    		get=function() return self.db.profile.LoSRFoL end,
    		set=function() BangLibramSwap:LoSRFoL() end,

            },
	    
	        PVPFlashofLightHeader = {
            type = "header",
            name = "PVP Flash of Light Librams:",
            desc = " ",
            order = 20,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	   
	        Glad1 = {
            type = "toggle",
            name = "Gladiator's Libram of Justice",
            desc = "Toggle the Gladiator's Libram of Justice",
            width = "full",
			order = 21,
    		get=function() return self.db.profile.Glad1 end,
    		set=function() BangLibramSwap:Glad1() end,

            },

            Glad2 = {
            type = "toggle",
            name = "Merciless Gladiator's Libram of Justice",
            desc = "Toggle the Merciless Gladiator's Libram of Justice",
            order = 22,
            width = "full",
    		get=function() return self.db.profile.Glad2 end,
    		set=function() BangLibramSwap:Glad2() end,

             },

       

	        Glad3 = {
             type = "toggle",
            name = "Vengeful Gladiator's Libram of Justice",
            desc = "Toggle the Vengeful Gladiator's Libram of Justice",
            width = "full",
			order = 23,
    		get=function() return self.db.profile.Glad3 end,
    		set=function() BangLibramSwap:Glad3() end,

            },
        
            Glad4 = {
             type = "toggle",
            name = "Brutal Gladiator's Libram of Justice",
            desc = "Toggle the Brutal Gladiator's Libram of Justice",
            width = "full",
			order = 24,
    		get=function() return self.db.profile.Glad4 end,
    		set=function() BangLibramSwap:Glad4() end,

            },
        
            ExtraHolyHeader = {
            type = "header",
            name = "Holy Spell Damage Librams:",
            desc = " ",
            order = 25,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	   
	        HolyDP = {
            type = "toggle",
            name = "Libram of Divine Purpose",
            desc = "Use the Libram of Divine Purpose while Judging in Holy mode",
            width = "full",
			order = 26,
    		get=function() return self.db.profile.HolyDP end,
    		set=function() BangLibramSwap:HolyDP() end,

            },

            HolyES = {
            type = "toggle",
            name = "Libram of Wracking",
            desc = "Use the Libram of Wracking on Exocism and Holy Wrath",
            order = 27,
            width = "full",
    		get=function() return self.db.profile.HolyES end,
    		set=function() BangLibramSwap:HolyES() end,

             },

       

	        HolyCD = {
             type = "toggle",
            name = "Libram of the Eternal Rest",
            desc = "Use the Libram of the Eternal Rest on Consecration",
            width = "full",
			order = 28,
    		get=function() return self.db.profile.HolyCD end,
    		set=function() BangLibramSwap:HolyCD() end,

            },
        
	        } -- Args Holy Librams
	        
	        }, -- Frame Holy librams
	        
	    frame3 = {    
	   
	type="group",
    name = "Ret Librams",
    childGroups = "tab",
    plugins = {},
    args = {
	   
	        RetCrusaderStrikeHeader = {
            type = "header",
            name = "Crusader Strike Librams:",
            desc = " ",
            order = 30,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        RetRP = {
            type = "toggle",
            name = "Libram of Righteous Power",
            width = "full",
            desc = "Toggle the Libram of Righteous Power",
            order = 31,
    		get=function() return self.db.profile.RP end,
    		set=function() BangLibramSwap:RetRP() end,

        	},
	   
	        RetPVEJudgementHeader = {
            type = "header",
            name = "PVE Judgement Librams:",
            desc = " ",
            order = 32,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        RetDJ = {
            type = "toggle",
            name = "Libram of Divine Judgement",
            width = "full",
            desc = "Toggle the Libram of Divine Judgement",
            order = 33,
    		get=function() return self.db.profile.DJ end,
    		set=function() BangLibramSwap:RetDJ() end,

        	},
        	
        	  RetAV = {
            type = "toggle",
            name = "Libram of Avengement",
            width = "full",
            desc = "Toggle the Libram of Avengement",
            order = 34,
    		get=function() return self.db.profile.AV end,
    		set=function() BangLibramSwap:RetAV() end,

        	},
	   
	        RetPVPJudgementHeader = {
            type = "header",
            name = "PVP Judgement Librams:",
            desc = " ",
            order = 35,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        RetJudge1 = {
            type = "toggle",
            name = "Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Toggle Gladiator's Libram of Fortitude",
            order = 36,
    		get=function() return self.db.profile.RetJudge1 end,
    		set=function() BangLibramSwap:RetJudge1() end,

        	},
        	
        	  RetJudge2 = {
            type = "toggle",
            name = "Merciless Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Toggle Merciless Gladiator's Libram of Fortitude",
            order = 37,
    		get=function() return self.db.profile.RetJudge2 end,
    		set=function() BangLibramSwap:RetJudge2() end,

        	},
        	
        	RetJudge3 = {
            type = "toggle",
            name = "Vengeful Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Toggle Vengeful Gladiator's Libram of Fortitude",
            order = 38,
    		get=function() return self.db.profile.RetJudge3 end,
    		set=function() BangLibramSwap:RetJudge3() end,

        	},
        	
        	  RetJudge4 = {
            type = "toggle",
            name = "Brutal Gladiator's Libram of Fortitude",
            width = "full",
            desc = "Brutal Gladiator's Libram of Fortitude",
            order = 39,
    		get=function() return self.db.profile.RetJudge4 end,
    		set=function() BangLibramSwap:RetJudge4() end,

        	},
	   
	        } -- Args Ret Librams
	        
	        }, -- Frame Ret librams
			
			frame4 = {    
	   
	type="group",
    name = "Prot Librams",
    childGroups = "tab",
    plugins = {},
    args = {
	   
	   
	       ProtHolyShieldHeader = {
            type = "header",
            name = "Holy Shield Librams:",
            desc = " ",
            order = 40,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        ProtHS = {
            type = "toggle",
            name = "Libram of Repentance",
            width = "full",
            desc = "Toggle the Libram of Repentance",
            order = 41,
    		get=function() return self.db.profile.HS end,
    		set=function() BangLibramSwap:ProtHS() end,

        	},
	   
	        ProtJudgementHeader = {
            type = "header",
            name = "PVE Judgement Librams:",
            desc = " ",
            order = 42,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        ProtDP = {
            type = "toggle",
            name = "Libram of Divine Purpose",
            width = "full",
            desc = "Toggle the Libram of Divine Purpose",
            order = 43,
    		get=function() return self.db.profile.ProtDP end,
    		set=function() BangLibramSwap:ProtDP() end,

        	},
        	
        	  ProtTotL = {
            type = "toggle",
            name = "Tome of the Lightbringer",
            width = "full",
            desc = "Toggle the Tome of the Lightbringer",
            order = 44,
    		get=function() return self.db.profile.JB end,
    		set=function() BangLibramSwap:ProtJB() end,

        	},
	   
	        RetPVPJudgementHeader = {
            type = "header",
            name = "PVP Prot Librams:",
            desc = " ",
            order = 45,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },
	         
	         
	        ProtPVPJudge1 = {
            type = "description",
            name = "You *cannot* be serious?",
            width = "full",
            desc = " ",
            order = 46,
    		get=function() return self.db.profile.RetJudge1 end,
    		set=function() BangLibramSwap:RetJudge1() end,
			}
			
            } -- Args Prot Librams
	        
	        }, -- Frame Prot librams   
	   
        	frame5 = {    
	   
	type="group",
    name = "About",
    childGroups = "tab",
    plugins = {},
    args = {
	   
	   
	       AboutHeader = {
            type = "header",
            name = "About Bang! Holy Librams",
            desc = " ",
            order = 50,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         },  	   
	   
	         AboutDescription = {
            type = "description",
            name = "Bang! Holy Librams: By Bangerz of Jubei'thos Oceanic!",
            desc = " ",
            order = 51,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	              AboutDescription2 = {
            type = "description",
            name = "The Ultimate Smart Paladin Libram Swapper: Check the librams you want to use in the three tabs here. Using Auto Change Spec and  Detect PVP/PVE is highly reccomended.",
            desc = " ",
            order = 52,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
			  
			  
			      AboutDescription3 = {
            type = "description",
            name = " ",
            desc = " ",
            order = 53,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	          AboutDescription4 = {
            type = "description",
            name = "Primary Mod Website: http://www.curse.com/downloads/details/12351",
            desc = " ",
            order = 54,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	         
	          AboutDescription5 = {
            type = "description",
            name = "Accepting localizations for your clients language, simply modify localization.lua and post it in a ticket at the above site.",
            desc = " ",
            order = 55,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	            AboutDescription6 = {
            type = "description",
            name = "Proud member of <Fade>: www.FadeGuild.com.au",
            desc = " ",
            order = 56,
    		get=function() return self.db.profile.LoAT end,
    		set=function() BangLibramSwap:LoAT() end,
	         }, 
	   
	        } -- Args About
	        
	        }, -- Frame 5
	   
	   }, } -- Profile, Options


    self:RegisterChatCommand("bls", "ChatCommand")
    self:RegisterChatCommand("BangLibramSwap", "ChatCommand")
 	self.db = LibStub("AceDB-3.0"):New("BangLibramSwapDB", defaults, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("BangLibramSwap", options)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("BangLibramSwap", "BangLibramSwap")

    if (self.db.profile.Debug) then DEFAULT_CHAT_FRAME:AddMessage("BLS: Debug On", 1.0, 0.85, 0.43)  end
		if (not (self.db.profile.STFU3)) then
 			DEFAULT_CHAT_FRAME:AddMessage("Bang! Libram Swap v2.42.J First Time Loaded: /bls (for options)", 1.0, 0.85, 0.43)
        self.db.profile.STFU3 = true
    end

end

function BangLibramSwap:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToFrame("BangLibramSwap")
       -- InterfaceOptionsFrame_OpenToFrame(BangLibramSwapoptionsFrame)
    else
        BangLibramSwap:slashHandler(input)
    end
end

function BangLibramSwap:slashHandler(input)
local self = BangLibramSwap
  if input == "gui" then
     InterfaceOptionsFrame_OpenToFrame("BangLibramSwap")
  elseif input == "pve" then
  DEFAULT_CHAT_FRAME:AddMessage("BLS: PVE Mode", 1.0, 0.85, 0.43)
    self.db.profile.Mp5Mode = true;
  elseif input == "pvp" then
  DEFAULT_CHAT_FRAME:AddMessage("BLS: PVP Mode", 1.0, 0.85, 0.43)
    self.db.profile.Mp5Mode = false;
  elseif input == "debug" then
  DEFAULT_CHAT_FRAME:AddMessage("BLS: Debug", 1.0, 0.85, 0.43)
  DEFAULT_CHAT_FRAME:AddMessage("/cast [target=Bangerz] Blessing of Freedom", 1.0, 0.85, 0.43)
    if (self.db.profile.Debug) then
    self.db.profile.Debug = false
    else
    self.db.profile.Debug = true
    end
  else
    DEFAULT_CHAT_FRAME:AddMessage(self.db.profile.Version, 1.0, 0.85, 0.43)
    DEFAULT_CHAT_FRAME:AddMessage("/bls gui", 1.0, 0.85, 0.43)
  end
end

function BangLibramSwap:SetLoMRecast(value)
self.db.profile.RefreshWindow = value

end

function BangLibramSwap:LoAT()
		self.db.profile.LotL = false;
        self.db.profile.LoM = false;
		self.db.profile.LoAT = true;
end

function BangLibramSwap:LotL()
		self.db.profile.LotL = true
        self.db.profile.LoM = false
		self.db.profile.LoAT = false;
end

function BangLibramSwap:BBoN()
		self.db.profile.LoL = false
        self.db.profile.BBoN = true;
end

function BangLibramSwap:LoL()
		self.db.profile.LoL = true
        self.db.profile.BBoN = false;
end

function BangLibramSwap:LoSR()
        if (self.db.profile.LoSR) then
        self.db.profile.LoSR = false
        else
		self.db.profile.LoSR = true
		end
end

function BangLibramSwap:LoSRFoL()
        if (self.db.profile.LoSRFoL) then
        self.db.profile.LoSRFoL = false
        else
		self.db.profile.LoSRFoL = true
		end
end

function BangLibramSwap:LoM()
		if (not(self.db.profile.LoM)) then
		self.db.profile.LotL = false
        self.db.profile.LoSR = false
        self.db.profile.LoM = true
        self.db.profile.NoLoM = false
        self.db.profile.UseLoM = false
		self.db.profile.LoAT = false;
		else
		self.db.profile.LoM = false
		end
 end

function BangLibramSwap:NoLoM()
        if (not(self.db.profile.NoLoM)) then
        self.db.profile.LoM = false
        self.db.profile.UseLoM = false
        self.db.profile.NoLoM = true;
		else
		self.db.profile.NoLoM = false;
		end
end
function BangLibramSwap:UseLoM()
        if (not(self.db.profile.UseLoM)) then
        self.db.profile.UseLoM = true
        self.db.profile.NoLoM = false
		else
		self.db.profile.UseLoM = false
		end
end
	
function BangLibramSwap:Glad1()
        if (not(self.db.profile.Glad1)) then
		self.db.profile.Glad1 = true
        self.db.profile.Glad2 = false
        self.db.profile.Glad3 = false
		self.db.profile.Glad4 = false
		end
end
function BangLibramSwap:Glad2()
        if (not(self.db.profile.Glad2)) then
		self.db.profile.Glad2 = true
        self.db.profile.Glad1 = false
        self.db.profile.Glad3 = false
		self.db.profile.Glad4 = false
		end
end
function BangLibramSwap:Glad3()
        if (not(self.db.profile.Glad3)) then
		self.db.profile.Glad3 = true
        self.db.profile.Glad2 = false
        self.db.profile.Glad1 = false
		self.db.profile.Glad4 = false
		end
end
function BangLibramSwap:Glad4()
        if (not(self.db.profile.Glad4)) then
        self.db.profile.Glad3 = false
        self.db.profile.Glad2 = false
        self.db.profile.Glad1 = false
		self.db.profile.Glad4 = true
		end
end

function BangLibramSwap:RetJudge1()
        if (not(self.db.profile.RetJudge1)) then
		self.db.profile.RetJudge1 = true
        self.db.profile.RetJudge2 = false
        self.db.profile.RetJudge3 = false
		self.db.profile.RetJudge4 = false
		else
		self.db.profile.RetJudge1 = false
		end
end
function BangLibramSwap:RetJudge2()
        if (not(self.db.profile.RetJudge2)) then
		self.db.profile.RetJudge2 = true
        self.db.profile.RetJudge1 = false
        self.db.profile.RetJudge3 = false
		self.db.profile.RetJudge4 = false
		else
		self.db.profile.RetJudge2 = false
		end
end
function BangLibramSwap:RetJudge3()
        if (not(self.db.profile.RetJudge3)) then
		self.db.profile.RetJudge3 = true
        self.db.profile.RetJudge2 = false
        self.db.profile.RetJudge1 = false
		self.db.profile.RetJudge4 = false
		else
		self.db.profile.RetJudge3 = false
		end
end
function BangLibramSwap:RetJudge4()
        if (not(self.db.profile.RetJudge4)) then
        self.db.profile.RetJudge3 = false
        self.db.profile.RetJudge2 = false
        self.db.profile.RetJudge1 = false
		self.db.profile.RetJudge4 = true
		else
		self.db.profile.RetJudge4 = false
		end
end

function BangLibramSwap:RetRP()
        if (not(self.db.profile.RP)) then
				self.db.profile.RP = true;
		else
			    self.db.profile.RP = false;
		end
end
function BangLibramSwap:RetDJ()
      if (not(self.db.profile.DJ)) then
      self.db.profile.DJ = true
      self.db.profile.AV = false;
      else
      self.db.profile.DJ = false;

     end
end
function BangLibramSwap:RetAV()
      if (not(self.db.profile.AV)) then
      self.db.profile.AV = true
      self.db.profile.DJ = false;
      else
      self.db.profile.AV = false;
     end
end

function BangLibramSwap:ProtHS()
        if (not(self.db.profile.HS)) then
		self.db.profile.HS = true;
		else
		self.db.profile.HS = false;
		end
end
function BangLibramSwap:ProtJB()
        if (not(self.db.profile.JB)) then
        self.db.profile.JB = true
        self.db.profile.ProtDP = false;
        else
         self.db.profile.JB = false;
		end
end
function BangLibramSwap:ProtDP()
        if (not(self.db.profile.ProtDP)) then
        self.db.profile.JB = false
        self.db.profile.ProtDP = true;
        else
        self.db.profile.ProtDP = false;
		end
end

function BangLibramSwap:HolyDP()
        if (not(self.db.profile.HolyDP)) then
           self.db.profile.HolyDP = true;

		else
        	self.db.profile.HolyDP = false;
		end

end
function BangLibramSwap:HolyES()
        if (not(self.db.profile.HolyES)) then
           self.db.profile.HolyES = true;

		else
        	self.db.profile.HolyES = false;
        end
end
function BangLibramSwap:HolyCD()
		if (not(self.db.profile.HolyCD)) then
            self.db.profile.HolyCD = true;
		else
        	self.db.profile.HolyCD = false;
        end
end


function BangLibramSwap:SetPVEMode()
	if self.db.profile.Mp5Mode then
		self.db.profile.Mp5Mode = false
	else
		self.db.profile.Mp5Mode = true
	end
end
function BangLibramSwap:SetPVPMode()
	if self.db.profile.Mp5Mode then
		self.db.profile.Mp5Mode = false
	else
		self.db.profile.Mp5Mode = true
	end
end
function BangLibramSwap:SetHolyMode(v)
        self.db.profile.holy = true
		self.db.profile.prot = false
		self.db.profile.ret = false
end
function BangLibramSwap:SetRetMode(v)
        self.db.profile.holy = false
		self.db.profile.prot = false
		self.db.profile.ret = true
end
function BangLibramSwap:SetProtMode(v)
        self.db.profile.holy = false
		self.db.profile.prot = true
		self.db.profile.ret = false
end
function BangLibramSwap:SetAutoMode()
	if (self.db.profile.AutoMode) then
		self.db.profile.AutoMode = false
	else
		self.db.profile.AutoMode = true
	end
end
function BangLibramSwap:SetAutoSpec()
	if (self.db.profile.AutoSpec) then
		self.db.profile.AutoSpec = false
	else
		self.db.profile.AutoSpec = true
	end
end
function BangLibramSwap:SetEnabled()
	if (self.db.profile.Enabled) then
		self.db.profile.Enabled = false
	else
		self.db.profile.Enabled = true
	end
end
function BangLibramSwap:SetDebug()
	if (self.db.profile.Debug) then
		self.db.profile.Debug = false
	else
		self.db.profile.Debug = true
	end
end

function BangLibramSwap:OnEnable()
self:RegisterEvent("UNIT_SPELLCAST_SENT")
--self:RegisterEvent("UNIT_SPELLCAST_START")
self:RegisterEvent("VARIABLES_LOADED")
self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
self:RegisterEvent("ZONE_CHANGED")
end





function BangLibramSwap:VARIABLES_LOADED(event)
	
end

function BangLibramSwap:ZONE_CHANGED()
end
	
function BangLibramSwap:SPELL_UPDATE_COOLDOWN(event)
     BangLibramSwap:IsJudgementUp()
end

function BangLibramSwap:COMBAT_LOG_EVENT_UNFILTERED(event)

   local LoRP = L["Libram of Righteous Power"]  -- +36 Crusader strike
   local LoDJ = L["Libram of Divine Judgement"] -- JoC proc 200AP
   local LoAV = L["Libram of Avengement"] -- JoC proc crit rating
   local LoDP = L["Libram of Divine Purpose"]   -- +97 Righteousness
   local LoCD = L["Libram of the Eternal Rest"] -- +47 concecrate
   local LoES = L["Libram of Wracking"]  		 -- +120 Ex/HW
   local LoHS = L["Libram of Repentance"]     	-- +5% Holy shield block
   local LoJB = L["Tome of the Lightbringer"] 	 -- +189 block value

   local BGLF  = L["Brutal Gladiator's Libram of Fortitude"] 	-- +36 resil
   local VGLF  = L["Vengeful Gladiator's Libram of Fortitude"] 	-- +36 resil
   local MGLF  = L["Merciless Gladiator's Libram of Fortitude"]   -- + 32 resil
   local GLF  = L["Gladiator's Libram of Fortitude"] 		    -- 24 resil

  		    -- Judgement logic. Prot
 			if (BangLibramSwap:IsProtJudgementUp()) and (self.db.profile.prot) and (self.db.profile.Enabled) and (not (BangLibramSwap:HSGCD())) then
			  		if (self.db.profile.JB) then
			  			if (self.db.profile.prot) then
						self:Debug("Equipping", LoJB)
					   	EquipItemByName(LoJB)
					   	end
					end
 			end



  			if (BangLibramSwap:IsJudgementUp()) and (self.db.profile.ProtDP) and (self.db.profile.prot) and (self.db.profile.Enabled) and (not (BangLibramSwap:HSGCD()) ) then
   			  	  		self:Debug("Equipping", LoDP)
					   EquipItemByName(LoDP)
  			end


   			-- Holy Shield Logic
            if (BangLibramSwap:HSUp()) and (self.db.profile.Enabled)  then
			  		if (self.db.profile.HS) then
			  			if (self.db.profile.prot) then
						self:Debug("Equipping", LoHS)
					   	EquipItemByName(LoHS)
					   	end
					end
 		    end

 			-- Crusader Strike logic
   			if (self.db.profile.ret) and (self.db.profile.RP)  and (self.db.profile.Enabled) then

   	 		  if (not(BangLibramSwap:Execute())) then
	   
   	   		 	if (not (BangLibramSwap:IsJudgementUp()) ) then
        		local itemname, itemlink, rarity, _, _, _, _, _, _, _ = GetInventoryItemLink("player",GetInventorySlotInfo("RangedSlot"))    --return the item name and rarity
	   	 			if (not (itemname == "Libram of Righteous Power")) then
   	        			if (not(BangLibramSwap:JudgementCD2())) and (BangLibramSwap:CSCD2()) then
			 				if (not (BangLibramSwap:Overlap2()) )then
   	  						self:Debug("Equipping", LoRP)
			  	    		EquipItemByName(LoRP)
			  				end
            			else
        				self:Debug("Potential GCD, Judge->CS swap aborted", 1.0, 0.85, 0.43)
		    			end   -- end GCD check and swaps
		   			else
		   			self:Debug("3) CS libram already in - cancel", 1.0, 0.85, 0.43)
		  			end  -- end itemname libram check
        		end   -- end judgement used check

	  		  end -- end Execute check
	 
   		     end  --- end retmode check

end  -- End Event



-- Prot Mode [ Standard cooldowns + latency/delay for event ]
function BangLibramSwap:IsProtJudgementUp()

    local start, duration, enabled = GetSpellCooldown(L["Judgement"])
    local cd = (start + duration) - GetTime()
   if (cd) then
	if (cd < 2.3) and (cd > 0) then
	     return true
	else
	     return false
	end
   end
end

function BangLibramSwap:HSGCD()

    local start, duration, enabled = GetSpellCooldown(L["Holy Shield"])
    local cd = (start + duration) - GetTime()
   if (cd) then
	if (cd < 1.7) and (cd > 0) then
	     return true
	else
	     return false
	end
   end
end

function BangLibramSwap:Execute()
local usable, nomana = IsUsableSpell(L["Hammer of Wrath"])

	if usable == 1 then return true
	else return false
	end

end

function BangLibramSwap:HSUp()

    local start, duration, enabled = GetSpellCooldown(L["Judgement"])
    local cd = (start + duration) - GetTime()
   if (cd) then
	if (cd > 2) and (cd < 10) then
	     return true
	else
	     return false
	end
   end
end

function BangLibramSwap:IsJudgementUp()

    local start, duration, enabled = GetSpellCooldown(L["Judgement"])
    local cd = (start + duration) - GetTime()
   if (cd) then
	if (cd > 1.5) and (cd < 11) then
	     return false
	else
	     return true
	end
   end
end



-- Ret Mode MK.II [Agressive GCDs - Judgement is off GCD of CS. Poor rotations may case GCD issues]

function BangLibramSwap:JudgementCD2()  -- Ret Mode

    local start, duration, enabled = GetSpellCooldown(L["Judgement"])  --, BOOKTYPE_SPELL
	local cd = (start + duration) - GetTime()
--	DEFAULT_CHAT_FRAME:AddMessage("Judge <2 and >6.5?  "..cd, 1.0, 0.85, 0.43)
   if (cd) then
	if ((cd < .5) and (cd > 0)) or ((cd > 7.5) and (cd < 10.1)) then
	return true
	else
	return false
	end
   end

end



function BangLibramSwap:CSCD2()  -- Ret Mode

	local start, duration, enabled = GetSpellCooldown(L["Crusader Strike"])  --, BOOKTYPE_SPELL
	local cd = (start + duration) - GetTime()
   if (cd) then
	if (cd > 1.5) and (cd < 6.1) then
	return true
	else
	return false
	end
   end

end

-- Ret Mode [Agressive overlap - prevent inferior CS libram from swapping in if cooldowns are close]

function BangLibramSwap:Overlap2()

	local start, duration, enabled = GetSpellCooldown(L["Crusader Strike"])  --, BOOKTYPE_SPELL
	local cd = (start + duration) - GetTime()
	
	local starts, durations, enableds = GetSpellCooldown(L["Judgement"])  --, BOOKTYPE_SPELL
	local cds = (starts + durations) - GetTime()
	



   if (cd < 6) and (cd > 0) and (cds >0) and (cds < 6) then
	if ((cd - cds) < 1.5) or ((cds - cd < 1.5)) or ((6 - cds < 1.5) and (6 - cds > 0))  then
	return true
	else
	return false
	end
   end

end


function BangLibramSwap:UNIT_SPELLCAST_SENT(event, unit, spell, rank, targ)
if (unit ~= "player") then return end
   local LoSR = L["Libram of Souls Redeemed"]   -- BoL 60/120
   local BBoN = L["Blessed Book of Nagrand"]    -- FoL +78
   local LoAT = L["Libram of Absolute Truth"]   -- HL -37 mana
   local LoM  = L["Libram of Mending"]          -- HL 22mp5
   local LotL = L["Libram of the Lightbringer"] -- HL +89
   local LoL  = L["Libram of Light"]            -- FoL +82
   local BGL  = L["Brutal Gladiator's Libram of Justice"] 	-- +36 resil
   local VGL  = L["Vengeful Gladiator's Libram of Justice"] 	-- +36 resil
   local MGL  = L["Merciless Gladiator's Libram of Justice"]   -- + 32 resil
   local GGL  = L["Gladiator's Libram of Justice"] 		    -- 24 resil

   local BGLF  = L["Brutal Gladiator's Libram of Fortitude"] 	-- +36 resil
   local VGLF  = L["Vengeful Gladiator's Libram of Fortitude"] 	-- +36 resil
   local MGLF  = L["Merciless Gladiator's Libram of Fortitude"]   -- + 32 resil
   local GLF  = L["Gladiator's Libram of Fortitude"] 		    -- 24 resil

   local LoRP = L["Libram of Righteous Power"]  -- +36 Crusader strike
   local LoDJ = L["Libram of Divine Judgement"] -- JoC proc 200AP
   local LoAV = L["Libram of Avengement"] -- JoC proc crit rating
   
   local LoDP = L["Libram of Divine Purpose"]   -- +97 Righteousness
   local LoCD = L["Libram of the Eternal Rest"] -- +47 concecrate
   local LoES = L["Libram of Wracking"]  		 -- +120 Ex/HW
   
   local LoHS = L["Libram of Repentance"]     	-- +5% Holy shield block
   local LoJB = L["Tome of the Lightbringer"] 	 -- +189 block value
   

   
	-- Auto Spec Selection, Holy is in the spells.

if (spell == L["Crusader Strike"]) then
	if (self.db.profile.AutoSpec) then
      self.db.profile.ret = true
      self.db.profile.holy = false
	  self.db.profile.prot = false
	 end

end

if (spell == L["Holy Shield"]) then
   if (self.db.profile.AutoSpec) then
       self.db.profile.prot = true
       self.db.profile.holy = false
       self.db.profile.ret = false
   end

end

  --CS logic. Ret
    
   	if (spell == L["Crusader Strike"]) and (self.db.profile.ret) and (self.db.profile.Enabled) then


   	    if not     (BangLibramSwap:JudgementCD2() )    then
              -- Start Auto PVP Selection 
			if (self.db.profile.AutoMode)  then
   	
   	
  			if (not (self.db.profile.Mp5Mode)) and IsInInstance() and (not  (  (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena()) )  ) then
    				self.db.profile.Mp5Mode = true,
    				self:Debug("BLS: PVE Mode Forced - You're in an instance!", 1.0, 0.85, 0.43)
 			 elseif not(IsInInstance() and (not   ( (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena()) )  )) then
				  if (BangLibramSwap:UnitIsPVP("target")) then
	 				 if (self.db.profile.Mp5Mode) then
	  				  	self:Debug("Target is PVP Enabled - Overriding PVE Mode", VGL)
	  	 			 	self.db.profile.Mp5Mode = false
		 			end
		 
	  			else
	  
	    			  if (not (self.db.profile.Mp5Mode)) then
	  	 			 	 self:Debug("Target is *not* PVP Enabled - Overriding PVP Mode", BBoN)
	  	 			 	 self.db.profile.Mp5Mode = true
	  				  end
	  	  
	 			 end
 		  end	  

  end   -- End Automatic selection                
					if (self.db.profile.Mp5Mode) or (not ((self.db.profile.RetJudge1) or (self.db.profile.RetJudge2) or (self.db.profile.RetJudge3) or(self.db.profile.RetJudge4))) then
						if (self.db.profile.DJ) then
						self:Debug("Equipping", LoDJ)
			  	    	EquipItemByName(LoDJ)
						end
						if  (self.db.profile.AV) then
                        self:Debug("Equipping", LoAV)
			  	    	EquipItemByName(LoAV)
			  	    	end
			  	    	
			  	    elseif (not(self.db.profile.Mp5Mode)) then	
			  	    	
			  	    	if  (self.db.profile.RetJudge1) then
                        self:Debug("Equipping", GLF)
			  	    	EquipItemByName(GLF)
			  	    	end
			  	    	if  (self.db.profile.RetJudge2) then
                        self:Debug("Equipping", MGLF)
			  	    	EquipItemByName(MGLF)
			  	    	end
			  	    	if  (self.db.profile.RetJudge3) then
                        self:Debug("Equipping", VGLF)
			  	    	EquipItemByName(VGLF)
			  	    	end
			  	    		if  (self.db.profile.RetJudge4) then
                        self:Debug("Equipping", BGLF)
			  	    	EquipItemByName(BGLF)
			  	    	end
			  	    end
       	else
        	       self:Debug("Potential GCD, CS->Judge swap aborted", 1.0, 0.85, 0.43)
           	-- BangLibramSwap:SwapAfterGCD()
        end
   	end
   	
   -- Judgement logic. Holy
    if (spell == L["Judgement"]) and (self.db.profile.Enabled) and (self.db.profile.holy) and (self.db.profile.HolyDP) then
   	  		self:Debug("Equipping", LoDP)
			   EquipItemByName(LoDP)
   end
   

   -- Concecrate Logic
      if ((spell == L["Consecration"]) and  (self.db.profile.HolyCD)) and (     (self.db.profile.holy) or (   (self.db.profile.prot) and (not(self.db.profile.HS))   ) ) then
   	  		self:Debug("Equipping", LoCD)
			   EquipItemByName(LoCD)
   end
   
   -- Holy Wrath/Exorcism Logic
   if (spell == L["Exorcism"]) and (self.db.profile.holy) and (self.db.profile.HolyES) and (self.db.profile.Enabled) then
   	  		self:Debug("Equipping", LoES)
			   EquipItemByName(LoES)
   end
   
   if (spell == L["Holy Wrath"]) and (self.db.profile.holy) and (self.db.profile.HolyES) and (self.db.profile.Enabled)then
   	  		self:Debug("Equipping", LoES)
			   EquipItemByName(LoES)
   end
   

   
   -- Flash of Light logic
   if (spell == L["Flash of Light"]) and (self.db.profile.Enabled) and ((self.db.profile.holy) or (self.db.profile.AutoSpec))  then
   -- Start Auto Spec Selection  
	 if not (self.db.profile.holy) and (self.db.profile.AutoSpec) then
	    self.db.profile.holy = true
		self.db.profile.prot = false
		self.db.profile.ret = false

	 end
      -- Start Auto PVP Selection 
if (self.db.profile.AutoMode)  then
   	
   	
  if (not (self.db.profile.Mp5Mode)) and IsInInstance() and (not    (  (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena())  )   ) then
    	self.db.profile.Mp5Mode = true,
    	self:Debug("BLS: PVE Mode Forced - You're in an instance!", 1.0, 0.85, 0.43)
  elseif not(IsInInstance() and (not  (  (GetNumBattlefieldStats() > 1) or (IsActiveBattlefieldArena()) )  )) then
	  if (BangLibramSwap:UnitIsPVP("target")) then
	 	 if (self.db.profile.Mp5Mode) then
	  	  	self:Debug("Target is PVP Enabled - Overriding PVE Mode", VGL)
	  	  	self.db.profile.Mp5Mode = false
		 end
		 
	  else
	  
	      if (not (self.db.profile.Mp5Mode)) then
	  	  	 self:Debug("Target is *not* PVP Enabled - Overriding PVP Mode", BBoN)
	  	  	 self.db.profile.Mp5Mode = true
	  	  end
	  	  
	  end
   end	  

	  
	  
	  
	  
	  
   end   -- End Automatic selection
   
	  if (self.db.profile.Mp5Mode) then
            if (self.db.profile.LoL) and (not (self.db.profile.LoSRFoL)) then
         	   self:Debug("Equipping", LoL) 
			   EquipItemByName(LoL)
            elseif (self:HasBoL(targ)) and (self.db.profile.LoSRFoL) then
               self:Debug("Equipping", LoSR)
			   EquipItemByName(LoSR)
            else
               self:Debug("Equipping", BBoN)
			   EquipItemByName(BBoN)
			end
	  else
	         if (self.db.profile.Glad1) then
			  	self:Debug("Equipping", GGL)
			  	EquipItemByName(GGL)
			  end
			  
			  if (self.db.profile.Glad2) then
			  	 self:Debug("Equipping", MGL)
			  	 EquipItemByName(MGL)
			  end
			  
			  if (self.db.profile.Glad3) then
			  	 self:Debug("Equipping", VGL)
			  	 EquipItemByName(VGL)
			  end
			  
			    if (self.db.profile.Glad4) then
			  	 self:Debug("Equipping", BGL)
			  	 EquipItemByName(BGL)
			  end
			  
			  
	  end
   end

   -- Holy Light logic
   if (spell == L["Holy Light"]) and (self.db.profile.Enabled) and ((self.db.profile.holy) or (self.db.profile.AutoSpec)) then
     if not (self.db.profile.holy) and (self.db.profile.AutoSpec) then
  	 self.db.profile.holy = true
		self.db.profile.prot = false
		self.db.profile.ret = false

	 end
	 
	
	 
	 -- LoM Annoying bug fix
		if (LoMCast) then
    	LastLoMCast = GetTime() - LoMCast
    	end
    	
        
  		if (LastLoMCast) then
  			if (LastLoMCast < 30) then
				if ((LastLoMCast < 4) and (LastLoMCast > 0)) and (not (self:HasMendingBuff() ) ) then
				LoMCastRecently = true
				else
				LoMCastRecently = false
	            end
			else
			LoMCastRecently = false
	    	end
		end
		
	-- End annoying bug fix
	 
	 
	 
         if (((self:HasMendingBuff()) or (LoMCastRecently)) or (self.db.profile.NoLoM)) and (not (self.db.profile.LoM))  then
			if (self:HasBoL(targ)) then
            
               if (self.db.profile.LoAT) and (not (self.db.profile.LoM)) and (not (self.db.profile.LoSR))then
               --SetCVar("Sound_EnableSFX", "0")
			  	 self:Debug("Equipping", LoAT)
			  	 EquipItemByName(LoAT)
      			--SetCVar("Sound_EnableSFX", sfx)
			    elseif (self.db.profile.LoSR) and (not (self.db.profile.LoM)) then
       			--SetCVar("Sound_EnableSFX", "0")
				self:Debug("Equipping", LoSR)
               	EquipItemByName(LoSR)
                --SetCVar("Sound_EnableSFX", sfx)
				elseif (self.db.profile.LotL) and (not (self.db.profile.LoM)) then
				self:Debug("Equipping", LotL)
               	EquipItemByName(LotL)
				end

            else
               
			   if (self.db.profile.LoAT) and (not (self.db.profile.LoM)) then
      		   	  --SetCVar("Sound_EnableSFX", "0")
			  	 self:Debug("Equipping", LoAT)
			  	 EquipItemByName(LoAT)
       			--SetCVar("Sound_EnableSFX", sfx)
                 elseif (self.db.profile.LotL) and (not (self.db.profile.LoM)) then
      			--SetCVar("Sound_EnableSFX", "0")
				self:Debug("Equipping", LotL)
               	EquipItemByName(LotL)
                --SetCVar("Sound_EnableSFX", sfx)
				
				end

            end
			   
         else
         --SetCVar("Sound_EnableSFX", "0")
            self:Debug("Equipping", LoM)
            EquipItemByName(LoM)
		    LoMCast = GetTime()

            --SetCVar("Sound_EnableSFX", sfx)
         end
   
      end

   
end

-- BangLibramSwap:HasBoL and HasMendingBuff code from Ladenedge's Holy Librams.

function BangLibramSwap:HasBoL(target)

   return self:BuffByTexture(target, "Spell_Holy_PrayerOfHealing02") or
         self:BuffByTexture(target, "Spell_Holy_GreaterBlessingofLight")

end

function BangLibramSwap:UnitIsPVP()

   return UnitIsPVP("target") 

end




function BangLibramSwap:HasHolyShield(player)

	return self:BuffByTexture(player, "Spell_Holy_BlessingOfProtection")
end


function BangLibramSwap:HasMendingBuff()

   local mending_buff_name = L["Grace of the Naaru"]

   for id = 1,100 do
      local name, _, _, _, _, time_left = UnitBuff("player", id)
      if (not name or not time_left) then
         return false
      elseif (name == mending_buff_name) then
         self:Debug("Mending buff is active, timeleft: ", time_left)
         return time_left >= self.db.profile.RefreshWindow
      end
   end

end

function BangLibramSwap:BuffByTexture(unit, texture_to_find)

   for id = 1,100 do
      local _, _, texture = UnitBuff(unit, id)
      if (not texture) then
         return false
      elseif (texture == "Interface\\Icons\\" .. texture_to_find) then
         return true
      end
   end

end

function BangLibramSwap:Debug(e, s)

if (self.db.profile.Debug) then
      self:Print(e, s)
end

end

function BangLibramSwap:Print(e, s)


   DEFAULT_CHAT_FRAME:AddMessage(e.." "..s, 1.0, 0.85, 0.43)

end
